# coding: utf-8

"""
    CRS Conversion Service

    Provides conversion/transformation services from a source to a target CRS. A coordinate operation is a conversion if the source and target CRS share the same datum; the operation is called transformation if datum transformations are involved, i.e. source and target CRS do not share the same datum.

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import models into sdk package
from .models.any_crs_geo_json_feature import AnyCrsGeoJsonFeature
from .models.any_crs_geo_json_feature_collection import AnyCrsGeoJsonFeatureCollection
from .models.any_crs_geo_json_feature_geometry import AnyCrsGeoJsonFeatureGeometry
from .models.any_crs_geo_json_geometry import AnyCrsGeoJsonGeometry
from .models.any_crs_geo_json_geometry_collection import AnyCrsGeoJsonGeometryCollection
from .models.any_crs_geo_json_line_string import AnyCrsGeoJsonLineString
from .models.any_crs_geo_json_multi_line_string import AnyCrsGeoJsonMultiLineString
from .models.any_crs_geo_json_multi_point import AnyCrsGeoJsonMultiPoint
from .models.any_crs_geo_json_multi_polygon import AnyCrsGeoJsonMultiPolygon
from .models.any_crs_geo_json_point import AnyCrsGeoJsonPoint
from .models.any_crs_geo_json_polygon import AnyCrsGeoJsonPolygon
from .models.any_property import AnyProperty
from .models.convert_geo_json_request import ConvertGeoJsonRequest
from .models.convert_geo_json_response import ConvertGeoJsonResponse
from .models.convert_points_request import ConvertPointsRequest
from .models.convert_points_response import ConvertPointsResponse
from .models.convert_trajectory_request import ConvertTrajectoryRequest
from .models.convert_trajectory_response import ConvertTrajectoryResponse
from .models.error_response import ErrorResponse
from .models.point import Point
from .models.trajectory_station_in import TrajectoryStationIn
from .models.trajectory_station_out import TrajectoryStationOut

# import apis into sdk package
from .apis.crs_point_conversion_api import CRSPointConversionApi
from .apis.trajectory_computation_and_conversion_api import TrajectoryComputationAndConversionApi

# import ApiClient
from .api_client import ApiClient

from .configuration import Configuration

configuration = Configuration()
