# coding: utf-8

"""
    CRS Conversion Service

    Provides conversion/transformation services from a source to a target CRS. A coordinate operation is a conversion if the source and target CRS share the same datum; the operation is called transformation if datum transformations are involved, i.e. source and target CRS do not share the same datum.

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class AnyCrsGeoJsonFeatureCollection(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, type=None, features=None, bbox=None, persistable_reference_crs=None, persistable_reference_unit_z=None):
        """
        AnyCrsGeoJsonFeatureCollection - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'features': 'list[AnyCrsGeoJsonFeature]',
            'bbox': 'list[float]',
            'persistable_reference_crs': 'str',
            'persistable_reference_unit_z': 'str'
        }

        self.attribute_map = {
            'type': 'type',
            'features': 'features',
            'bbox': 'bbox',
            'persistable_reference_crs': 'persistableReferenceCrs',
            'persistable_reference_unit_z': 'persistableReferenceUnitZ'
        }

        self._type = type
        self._features = features
        self._bbox = bbox
        self._persistable_reference_crs = persistable_reference_crs
        self._persistable_reference_unit_z = persistable_reference_unit_z

    @property
    def type(self):
        """
        Gets the type of this AnyCrsGeoJsonFeatureCollection.

        :return: The type of this AnyCrsGeoJsonFeatureCollection.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this AnyCrsGeoJsonFeatureCollection.

        :param type: The type of this AnyCrsGeoJsonFeatureCollection.
        :type: str
        """
        allowed_values = ["FeatureCollection", "AnyCrsFeatureCollection"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def features(self):
        """
        Gets the features of this AnyCrsGeoJsonFeatureCollection.

        :return: The features of this AnyCrsGeoJsonFeatureCollection.
        :rtype: list[AnyCrsGeoJsonFeature]
        """
        return self._features

    @features.setter
    def features(self, features):
        """
        Sets the features of this AnyCrsGeoJsonFeatureCollection.

        :param features: The features of this AnyCrsGeoJsonFeatureCollection.
        :type: list[AnyCrsGeoJsonFeature]
        """
        if features is None:
            raise ValueError("Invalid value for `features`, must not be `None`")

        self._features = features

    @property
    def bbox(self):
        """
        Gets the bbox of this AnyCrsGeoJsonFeatureCollection.

        :return: The bbox of this AnyCrsGeoJsonFeatureCollection.
        :rtype: list[float]
        """
        return self._bbox

    @bbox.setter
    def bbox(self, bbox):
        """
        Sets the bbox of this AnyCrsGeoJsonFeatureCollection.

        :param bbox: The bbox of this AnyCrsGeoJsonFeatureCollection.
        :type: list[float]
        """

        self._bbox = bbox

    @property
    def persistable_reference_crs(self):
        """
        Gets the persistable_reference_crs of this AnyCrsGeoJsonFeatureCollection.
        The spatial context of this AnyCrsGeoJsonFeatureCollection as persistable reference string.

        :return: The persistable_reference_crs of this AnyCrsGeoJsonFeatureCollection.
        :rtype: str
        """
        return self._persistable_reference_crs

    @persistable_reference_crs.setter
    def persistable_reference_crs(self, persistable_reference_crs):
        """
        Sets the persistable_reference_crs of this AnyCrsGeoJsonFeatureCollection.
        The spatial context of this AnyCrsGeoJsonFeatureCollection as persistable reference string.

        :param persistable_reference_crs: The persistable_reference_crs of this AnyCrsGeoJsonFeatureCollection.
        :type: str
        """

        self._persistable_reference_crs = persistable_reference_crs

    @property
    def persistable_reference_unit_z(self):
        """
        Gets the persistable_reference_unit_z of this AnyCrsGeoJsonFeatureCollection.
        The vertical axis unit for this AnyCrsGeoJsonFeatureCollection as persistable reference string.

        :return: The persistable_reference_unit_z of this AnyCrsGeoJsonFeatureCollection.
        :rtype: str
        """
        return self._persistable_reference_unit_z

    @persistable_reference_unit_z.setter
    def persistable_reference_unit_z(self, persistable_reference_unit_z):
        """
        Sets the persistable_reference_unit_z of this AnyCrsGeoJsonFeatureCollection.
        The vertical axis unit for this AnyCrsGeoJsonFeatureCollection as persistable reference string.

        :param persistable_reference_unit_z: The persistable_reference_unit_z of this AnyCrsGeoJsonFeatureCollection.
        :type: str
        """

        self._persistable_reference_unit_z = persistable_reference_unit_z

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AnyCrsGeoJsonFeatureCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
