# coding: utf-8

"""
    CRS Conversion Service

    Provides conversion/transformation services from a source to a target CRS. A coordinate operation is a conversion if the source and target CRS share the same datum; the operation is called transformation if datum transformations are involved, i.e. source and target CRS do not share the same datum.

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class AnyCrsGeoJsonFeatureGeometry(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, type=None, coordinates=None):
        """
        AnyCrsGeoJsonFeatureGeometry - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'coordinates': 'object'
        }

        self.attribute_map = {
            'type': 'type',
            'coordinates': 'coordinates'
        }

        self._type = type
        self._coordinates = coordinates

    @property
    def type(self):
        """
        Gets the type of this AnyCrsGeoJsonFeatureGeometry.
        the geometry type

        :return: The type of this AnyCrsGeoJsonFeatureGeometry.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this AnyCrsGeoJsonFeatureGeometry.
        the geometry type

        :param type: The type of this AnyCrsGeoJsonFeatureGeometry.
        :type: str
        """
        allowed_values = ["Point", "LineString", "Polygon", "MultiPoint", "MultiLineString", "MultiPolygon", "GeometryCollection", "AnyCrsPoint", "AnyCrsLineString", "AnyCrsPolygon", "AnyCrsMultiPoint", "AnyCrsMultiLineString", "AnyCrsMultiPolygon", "AnyCrsGeometryCollection"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def coordinates(self):
        """
        Gets the coordinates of this AnyCrsGeoJsonFeatureGeometry.

        :return: The coordinates of this AnyCrsGeoJsonFeatureGeometry.
        :rtype: object
        """
        return self._coordinates

    @coordinates.setter
    def coordinates(self, coordinates):
        """
        Sets the coordinates of this AnyCrsGeoJsonFeatureGeometry.

        :param coordinates: The coordinates of this AnyCrsGeoJsonFeatureGeometry.
        :type: object
        """

        self._coordinates = coordinates

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AnyCrsGeoJsonFeatureGeometry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
