# coding: utf-8

"""
    CRS Conversion Service

    Provides conversion/transformation services from a source to a target CRS. A coordinate operation is a conversion if the source and target CRS share the same datum; the operation is called transformation if datum transformations are involved, i.e. source and target CRS do not share the same datum.

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ConvertGeoJsonRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, feature_collection=None, to_crs=None, to_unit_z=None):
        """
        ConvertGeoJsonRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'feature_collection': 'AnyCrsGeoJsonFeatureCollection',
            'to_crs': 'str',
            'to_unit_z': 'str'
        }

        self.attribute_map = {
            'feature_collection': 'featureCollection',
            'to_crs': 'toCRS',
            'to_unit_z': 'toUnitZ'
        }

        self._feature_collection = feature_collection
        self._to_crs = to_crs
        self._to_unit_z = to_unit_z

    @property
    def feature_collection(self):
        """
        Gets the feature_collection of this ConvertGeoJsonRequest.

        :return: The feature_collection of this ConvertGeoJsonRequest.
        :rtype: AnyCrsGeoJsonFeatureCollection
        """
        return self._feature_collection

    @feature_collection.setter
    def feature_collection(self, feature_collection):
        """
        Sets the feature_collection of this ConvertGeoJsonRequest.

        :param feature_collection: The feature_collection of this ConvertGeoJsonRequest.
        :type: AnyCrsGeoJsonFeatureCollection
        """
        if feature_collection is None:
            raise ValueError("Invalid value for `feature_collection`, must not be `None`")

        self._feature_collection = feature_collection

    @property
    def to_crs(self):
        """
        Gets the to_crs of this ConvertGeoJsonRequest.
        The GeoJSON FeatureCollection or AnyCrsFeatureCollection structure to be converted/transformed. GeoJSON is always based on WGS 84; AnyCrsFeatureCollection carries the CRS context in the persistableReferenceCrs property

        :return: The to_crs of this ConvertGeoJsonRequest.
        :rtype: str
        """
        return self._to_crs

    @to_crs.setter
    def to_crs(self, to_crs):
        """
        Sets the to_crs of this ConvertGeoJsonRequest.
        The GeoJSON FeatureCollection or AnyCrsFeatureCollection structure to be converted/transformed. GeoJSON is always based on WGS 84; AnyCrsFeatureCollection carries the CRS context in the persistableReferenceCrs property

        :param to_crs: The to_crs of this ConvertGeoJsonRequest.
        :type: str
        """
        if to_crs is None:
            raise ValueError("Invalid value for `to_crs`, must not be `None`")

        self._to_crs = to_crs

    @property
    def to_unit_z(self):
        """
        Gets the to_unit_z of this ConvertGeoJsonRequest.
        The vertical axis unit for this AnyCrsGeoJsonFeatureCollection as persistable reference string.

        :return: The to_unit_z of this ConvertGeoJsonRequest.
        :rtype: str
        """
        return self._to_unit_z

    @to_unit_z.setter
    def to_unit_z(self, to_unit_z):
        """
        Sets the to_unit_z of this ConvertGeoJsonRequest.
        The vertical axis unit for this AnyCrsGeoJsonFeatureCollection as persistable reference string.

        :param to_unit_z: The to_unit_z of this ConvertGeoJsonRequest.
        :type: str
        """

        self._to_unit_z = to_unit_z

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ConvertGeoJsonRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
