# coding: utf-8

"""
    CRS Conversion Service

    Provides conversion/transformation services from a source to a target CRS. A coordinate operation is a conversion if the source and target CRS share the same datum; the operation is called transformation if datum transformations are involved, i.e. source and target CRS do not share the same datum.

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ConvertPointsRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, from_crs=None, to_crs=None, points=None):
        """
        ConvertPointsRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'from_crs': 'str',
            'to_crs': 'str',
            'points': 'list[Point]'
        }

        self.attribute_map = {
            'from_crs': 'fromCRS',
            'to_crs': 'toCRS',
            'points': 'points'
        }

        self._from_crs = from_crs
        self._to_crs = to_crs
        self._points = points

    @property
    def from_crs(self):
        """
        Gets the from_crs of this ConvertPointsRequest.
        Source CRS as persistable reference string

        :return: The from_crs of this ConvertPointsRequest.
        :rtype: str
        """
        return self._from_crs

    @from_crs.setter
    def from_crs(self, from_crs):
        """
        Sets the from_crs of this ConvertPointsRequest.
        Source CRS as persistable reference string

        :param from_crs: The from_crs of this ConvertPointsRequest.
        :type: str
        """
        if from_crs is None:
            raise ValueError("Invalid value for `from_crs`, must not be `None`")

        self._from_crs = from_crs

    @property
    def to_crs(self):
        """
        Gets the to_crs of this ConvertPointsRequest.
        Target CRS as persistable reference string

        :return: The to_crs of this ConvertPointsRequest.
        :rtype: str
        """
        return self._to_crs

    @to_crs.setter
    def to_crs(self, to_crs):
        """
        Sets the to_crs of this ConvertPointsRequest.
        Target CRS as persistable reference string

        :param to_crs: The to_crs of this ConvertPointsRequest.
        :type: str
        """
        if to_crs is None:
            raise ValueError("Invalid value for `to_crs`, must not be `None`")

        self._to_crs = to_crs

    @property
    def points(self):
        """
        Gets the points of this ConvertPointsRequest.
        List of points to be converted

        :return: The points of this ConvertPointsRequest.
        :rtype: list[Point]
        """
        return self._points

    @points.setter
    def points(self, points):
        """
        Sets the points of this ConvertPointsRequest.
        List of points to be converted

        :param points: The points of this ConvertPointsRequest.
        :type: list[Point]
        """
        if points is None:
            raise ValueError("Invalid value for `points`, must not be `None`")

        self._points = points

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ConvertPointsRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
