# coding: utf-8

"""
    CRS Conversion Service

    Provides conversion/transformation services from a source to a target CRS. A coordinate operation is a conversion if the source and target CRS share the same datum; the operation is called transformation if datum transformations are involved, i.e. source and target CRS do not share the same datum.

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ConvertPointsResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, success_count=None, points=None, operations_applied=None):
        """
        ConvertPointsResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'success_count': 'int',
            'points': 'list[Point]',
            'operations_applied': 'list[str]'
        }

        self.attribute_map = {
            'success_count': 'successCount',
            'points': 'points',
            'operations_applied': 'operationsApplied'
        }

        self._success_count = success_count
        self._points = points
        self._operations_applied = operations_applied

    @property
    def success_count(self):
        """
        Gets the success_count of this ConvertPointsResponse.
        Number of points successfully converted. If the number is less than the request array length conversion/transformation failures occurred.

        :return: The success_count of this ConvertPointsResponse.
        :rtype: int
        """
        return self._success_count

    @success_count.setter
    def success_count(self, success_count):
        """
        Sets the success_count of this ConvertPointsResponse.
        Number of points successfully converted. If the number is less than the request array length conversion/transformation failures occurred.

        :param success_count: The success_count of this ConvertPointsResponse.
        :type: int
        """

        self._success_count = success_count

    @property
    def points(self):
        """
        Gets the points of this ConvertPointsResponse.
        Converted points; length and order of the array is the same as in the request. Points, which failed to convert, are returned as NaN.

        :return: The points of this ConvertPointsResponse.
        :rtype: list[Point]
        """
        return self._points

    @points.setter
    def points(self, points):
        """
        Sets the points of this ConvertPointsResponse.
        Converted points; length and order of the array is the same as in the request. Points, which failed to convert, are returned as NaN.

        :param points: The points of this ConvertPointsResponse.
        :type: list[Point]
        """

        self._points = points

    @property
    def operations_applied(self):
        """
        Gets the operations_applied of this ConvertPointsResponse.
        The list of operations, which have been applied to the points

        :return: The operations_applied of this ConvertPointsResponse.
        :rtype: list[str]
        """
        return self._operations_applied

    @operations_applied.setter
    def operations_applied(self, operations_applied):
        """
        Sets the operations_applied of this ConvertPointsResponse.
        The list of operations, which have been applied to the points

        :param operations_applied: The operations_applied of this ConvertPointsResponse.
        :type: list[str]
        """

        self._operations_applied = operations_applied

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ConvertPointsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
